\section{Redundant computation in the STF model}
\label{sec:repl}

In a task-based programming model such as STF, modifications on a piece of data
are serialized. This means that two distinct workers managed by a runtime system will
not execute concurrently two tasks writing at the same memory addresses. While
this principle is important, ubiquitous operations such as reduction operations
rely on relaxing sequential consistency to perform efficiently.
In such a case, multiple copies of the to-be-reduced piece
of data coexist and while sequential consistency is ensured for each individual
copy, out-of-order execution will produce the same final result. Reductions
are only one such operation where a strict sequential consistency
could be relaxed momentarily.
This paper focuses on an approach that relaxes sequential consistency
to achieve \textbf{redundant computation}; this corresponds to the case
where multiple tasks, potentially on different computing nodes,
redundantly compute over the same data \emph{e.g.} the same submatrix $M_{ij}$ in a
distributed matrix $M$. As we will explain in the
following section, this feature can be used to reduce the
communications at the cost of a slight increase (often negligible)
in the operational complexity.

The present section is outlined as follows: first, we motivate the interest
of providing an interface to enable data replication in
Section~\ref{sec:repl.motiv}. Section~\ref{sec:repl.runtime} deals
with the actual specification of the related novel interface -- an
additional access mode \stfSAME.
%The next section demonstrates its use
%in a stencil application.
%The following section,
%Section~\ref{sec:repl.allredux}, is concerned with implementing an
%allreduce collective communication; this operation leads to the
%situation where multiple ranks own copies of the same data which can
%be concurrently updated through the redundant computation
%feature.
%This mechanism, implemented through the extensions presented
%in this capter, is actually leveraged in factorization algorithms.

\subsection{Motivation}
\label{sec:repl.motiv}

%In a reduction, one rank starts with a piece of data it owns and other
%ranks start with a copy initialized according to the program's
%specifications. Each rank partially contributes to its copy of the
%data that it will assemble. The assembled result is stored by the
%owner of the data. Such a pattern, rooted \textit{toward} the owner
%of the piece of data, is essential in several algorithms including the
%ones found in linear algebra computations.
 % It is a core component of
 % the extended STF programming model in
 % Capter~\ref{sec:stf-matrix-multiply}.
%On the contrary, a collective operation such as a broadcast can be
%described by a pattern that is is rooted \textit{from} the owner of a piece of
%data (see Figure~\ref{fig:dag.trees.bcast}).

One feature of interest is the replication of data output or data
modification. By replicating data modification, the same data is
modified on different distributed memories. We refer to this
behavior as \textbf{redundant computation}.
%the nomenclature of which has been
%carefully chosen and should not be confused with either \textit{data
%replication} which is not precise enough or \textit{task replication} which is
%not generic enough.
%even if the latter is not entirely accurate, as
%discussed in Section~\ref{sec:repl.redundant.same}:
The key component of the mechanism we present
is the concurrent modification of data.
%Because this mechanism requires
%the initial value of the modified data to be exchanged, the
%corresponding DAG is rooted \textit{from} the owner of the data.
As
the tasks modifying the data use the same input value, replication has
to break the consistency of the serial accesses over the data.  This
feature can be used to trade off communication with computation as
presented in Figure~\ref{fig:dag.repl}. If the DAG remains
sequentially consistent, the modification of a data $A$ may only be
executed in one place to produce successive versions. % $A_0$,$A_1$,\emph{etc.}.
If another
rank requires these values of $A$, multiple transfers between ranks
have to be executed, as depicted in the top part of the figure. By
replicating modifications of $A$ on the two ranks, those transfers
can be discarded: it is enough to transfer the initial value of $A$
and let the ranks proceed with the computation as depicted in the
bottom part of the figure.  If this alteration of the DAG is beneficial
to network communication, it is also clear that the computational
workload increases because some work has been duplicated. We
will see in Section~\ref{sec:repl.5pts} how this trade-off can improve
scalability in practice.

\begin{figure}
	\centering
	\begin{subfigure}[T]{0.45\columnwidth}
		\begin{tikzpicture}[scale=0.7]
			\pgfmathsetmacro{\c}{13pt}
			\pgfmathsetmacro{\l}{3pt}
			\pgfmathsetmacro{\m}{1}
			\pgfmathsetmacro{\dx}{0.8}
			\pgfmathsetmacro{\dX}{2.2}
			\node[fill=gray,circle,inner sep=0pt, minimum size=\c]
				(i) at (-2,\dx) {i};
			\foreach \y in {0,...,\m} {
				\node[fill=mygre!40,circle,inner sep=0pt, minimum size=\c]
					(re1\y) at (2*\y+0.2,\dx) {u};
				\node[fill=myorg!40,circle,inner sep=0pt, minimum size=\c]
					(r1\y) at (2*\y+0.6,\dX) {c};
				\node[fill=myorg!40,circle,inner sep=0pt, minimum size=\c]
					(r0\y) at (2*\y+0.4,-\dx) {c};
			}
			\path[-latex,ultra thick,draw] (i) -- (re10)
				node[midway,thin,fill=white,circle,minimum size=\l,inner sep=0pt] {$A_0$};
			\path[-latex,ultra thick,draw] (re10) -- (r10);
			\path[-latex,ultra thick,draw] (re10) -- (r00);
			\foreach \y in {1,...,\m} {
				\pgfmathsetmacro{\ym}{int(\y-1)}
				\path[-latex,draw,ultra thick] (re1\ym) -- (re1\y)
					node[midway,thin,fill=white,minimum width=\l,circle,inner sep=0pt] {$A_\y$};
				\path[-latex,draw,ultra thick] (re1\y) -- (r1\y);
				\path[-latex,draw,ultra thick] (re1\y) -- (r0\y);
			}
			\path[draw,ultra thick, dashed] (re1\m) -- ++(1,0);
			\path[dashed,draw] (-2,0) -- (2*\m+2,0);
      \node[anchor=south east] at (2*\m+2,0) {rk 0};
      \node[anchor=north east] at (2*\m+2,0) {rk 1};
		\end{tikzpicture}
	\end{subfigure}
	\hfill
	\begin{subfigure}[T]{0.45\columnwidth}
		\centering
		\begin{tikzpicture}[scale=0.7]
			\pgfmathsetmacro{\c}{13pt}
			\pgfmathsetmacro{\l}{5pt}
			\pgfmathsetmacro{\m}{1}
			\pgfmathsetmacro{\dx}{0.8}
			\pgfmathsetmacro{\dX}{2.2}
			\node[fill=gray,circle,inner sep=0pt, minimum size=\c] (i) at (-2,\dx) {i};
			\foreach \y in {0,...,\m} {
				\node[fill=mygre!40,circle,inner sep=0pt, minimum size=\c]
					(re1\y) at (2*\y+0.2,\dx) {u};
				\node[fill=myorg!40,circle,inner sep=0pt, minimum size=\c]
					(r1\y) at (2*\y+0.6,\dX) {c};
				\node[fill=mygre!40,circle,inner sep=0pt, minimum size=\c,dashed,thick]
					(re0\y) at (2*\y,-\dX) {u};
				\node[fill=myorg!40,circle,inner sep=0pt, minimum size=\c]
					(r0\y) at (2*\y+0.4,-\dx) {c};
			}
			\path[-latex,ultra thick,draw] (i) -- (re10)
				node[midway,fill=white,circle,minimum
size=\l,inner sep=0pt] {$A_0$};
			\path[-latex,ultra thick,draw] (i) -- (re00)
				node[midway,fill=white,circle,minimum
size=\l,inner sep=0pt] {$A_0$};
			\path[-latex,ultra thick,draw] (re10) -- (r10);
			\path[-latex,ultra thick,draw] (re00) -- (r00);
			\foreach \y in {1,...,\m} {
				\pgfmathsetmacro{\ym}{int(\y-1)}
				\path[-latex,draw,ultra thick] (re1\ym) -- (re1\y)
					node[midway,thin,fill=white,minimum width=\l,circle,inner sep=0pt] {$A_\y$};
				\path[-latex,draw,ultra thick] (re1\y) -- (r1\y);
				\path[-latex,draw,ultra thick] (re0\ym) -- (re0\y)
					node[midway,thin,fill=white,minimum width=\l,circle,inner sep=0pt] {$A_\y$};
				\path[-latex,draw,ultra thick] (re0\y) -- (r0\y);
			}
			\path[draw,ultra thick, dashed] (re1\m) -- ++(1,0);
			\path[draw,ultra thick, dashed] (re0\m) -- ++(1,0);
			\path[dashed,draw] (-2,0) -- (2*\m+2,0);
      \node[anchor=south east] at (2*\m+2,0) {rk 0};
      \node[anchor=north east] at (2*\m+2,0) {rk 1};
		\end{tikzpicture}
	\end{subfigure}
	\caption[A computation can be replicated to minimize transfers.]
	{Replicating modifications of a piece of data may reduce the
	communication volume if sequential consistency is relaxed.
	Orange tasks reads the value of $A$.
	Green tasks modifies the value of $A$.
	\textbf{Top:} Strict sequential consistency is maintained. Transfers
	are issued after each update task. \textbf{Bottom:} Sequential
	consistency is relaxed. One transfer is issued.}
	\label{fig:dag.repl}
\end{figure}

%\todoaj{more details on third pattern ?}
% Topology = pas étudié = risqué
%For the third pattern, it is unclear what would be the most reasonable
%assignments of modification tasks (green tasks) to ranks. In order to ease the
%decision, we will assume that the DAGs presented in Figure~\ref{fig:dag.trees}
%can be augmented  with network topology information: some ranks are closer
%(lower latency, higher bandwidth) to one another. This is typical in computing
%nodes with multiple NUMA domains where interconnection inside a computing node
%are more efficient than through the network. It makes sense to assign a rank to
%a single NUMA domain because cores tied to the same NUMA domain are more capable
%of sharing local data with one another. Network topology information should
%modify the shape of the different DAGs we have presented to favor performance:
%transfers between NUMA  domains should be favored over transfers over the
%network. In the case of a reduction pattern, ranks on the same computing node
%should compute their combined contribution and only then should the
%contributions be combined between  computing nodes. In the case of a broadcast
%taking the form of a binomial tree, a piece of data should be sent first to one
%rank across each computing node then from these receiving ranks to the ranks
%lying on the same computing node. The third pattern can also be presented in a
%way that match better with the network topology. Likewise a broadcast, one rank per
%computing node can be chosen that would receive the original piece of data
%before modifying it. The modified piece of data is then transferred through a
%broadcast tree on each computing node independently.

In the STF programming model,
%, including the extension proposed in
%Capter~\ref{sec:stf-matrix-multiply}
the sequential consistency remains
central and as such any relaxation of this property must be clearly framed.
For instance when dealing with reduction patterns, access modes
are defined to produce partial contributions which are not supposed
to be read nor used by an application in their partial state. When
considering replicating, a similar temporary relaxation should be provided by the runtime
system because a typical cache mechanism would cause concurrent modification to
invalidate one another in the same sequence as the same order as they have been
submitted. The next sections focus on framing the design that let the user relax
sequential consistency.
\begin{ab}
  le paragraphe ci-dessus n'est pas claire pour moi. Pourquoi on parle
  de cache? sans cache il n'y aurait pas de probleme?
\end{ab}

%The next sections are
%concerned with enabling this relaxation through an additional access mode
%\stfSAME as well as a feature to retrieve data using ranks different
%from the owner one.

% To a runtime system, the DAG is the principal representation that drives the
% execution. The directed graph structure guarantees a coherent scheduling of
% tasks. In a distributed memory setting however, it is interesting to explore algorithms
% where a strict coherence~-- in which any data is written over once by a
% single rank at a time~-- is relaxed. Capter~\ref{sec:stf-matrix-multiply}
% explores this idea when dealing with reduction patterns. In this capter,
% extensions of the STF programming model are explored to allow the replication of
% computation over several ranks that produce copies of a piece of data.

\subsection{Enabling redundant computation within STF}
\label{sec:repl.runtime}

%A task-based runtime system such as StarPU processes distributed memory tasks within a
%\texttt{insert\_mpi\_task} method described in Figure~\ref{alg:repl_insert}.
%A similar processing algorithm is proposed by \citeauthor{y:12} in his
%dissertation. Processing distributed task often involve more refined process to
%optimize transfers that are disregarded. The presented method first builds an internal
%representation of the task given the user's input. Once the task is built, this
%internal representation can hold information useful to the runtime such as
%dependencies or the ranks involved in the task. In order for the task to be
%executed by a selected rank, some data may need to be transferred over the
%network beforehand (Line~\ref{code:repl_insert_1}): this can be expressed
%through local tasks, automatically inserted by the runtime in the DAG, that describe
%these transfers to a communication library such as
%MPI~\cite{y:12,a.a.f.f.ea:17}. The actual submitted computation can then be
%inserted in the DAG (Line~\ref{code:repl_insert_2}): it will be %mechanically
%executed after the transfers are performed. For a piece of data $D$ owned by
%the rank $r$ and modified by a task executed by rank $x$ some specific actions
%may be required when $x \ne r$. Indeed $D$ has been modified in a different
%memory than it was originally stored.
%When $x\neq r$ many design choices arise
%because the only valid copy of $D$ that exists for subsequent tasks is stored in
%the memory of $x$.

%\citeauthor{y:12} details an approach to replicate the
%traversal of any DAG submitted to an STF runtime system.
One can assume that an arbitrary task $T$ in a DAG
modifies a single piece of data $D$ owned by
a given rank $P_{own}$. We can further assume that the rank executing
$T$ is $P_{exe}$ which is different from $P_{own}$. All the ranks have
registered $D$ as owned by $P_{own}$: a robust and simple way to
maintain coherency for subsequent tasks is to transfer the new value
of $D$ from the executing rank back to the owner once $T$ is executed.
StarPU plans these data
transfers during task submission. In any case, because the value of
$D$ has been modified, possible copies that are stored by other ranks
should be invalidated to make sure these ranks retrieve an up-to-date
copy when executing tasks in the remaining portion of the DAG~--
especially if a distributed-memory cache mechanism has been
implemented (as proposed
by~\citeauthor{a.a.f.f.ea:17}~\cite{a.a.f.f.ea:17}).
This section refines such a distributed-memory cache mechanism.

\subsubsection{Obtaining local data over multiple ranks}
\label{sec:repl.redundant.same}

The robust and systematic fallback to the owner contradicts the
redundant computation: two ranks cannot execute a task modifying
the same data without redundant transfers between one another,
possibly through the owner of the data.  A user can bypass this
behavior and implement replication by explicitly duplicating data %memory
managed by the runtime. This fundamentally leads to tricking the
runtime into thinking about the replicates and the original data as
completely separate references: instead of modifying a data $D$ owned
by $P_{own}$, the executing rank $P_{exe}$ can modify its own handle
$D^{(P_{exe})}$ that appears entirely different to the runtime. While
feasible, this approach may hurt readability as it provides an
inelegant expression that makes it uncomfortable to write code
productively. This approach might also lead to the creation of an
overhead for the runtime related to the management of the additional
data structures. %handles.

Rather than this approach, we propose the following extension to the
STF programming model: instead of inserting a task $T$ using a piece
of data $D$ with the usual \texttt{WRITE} access mode, an additional
access mode \stfSAME is introduced. This access mode actually
reduces to a flag over $D$ that indicates that copies are produced
across multiple ranks. The runtime is therefore not expected to
transfer these copies back to the original data owner: the transfer is
fundamentally bypassed. Such an access mode gives more manoeuvrability
to the user as they get to adjust the behavior of the runtime system
to their needs. Nonetheless, this approach puts more burden on the
user regarding the correctness of the DAG as several copies now exist
in the distributed memory whose consistency must be ensured.
Note that, semantically, the \stfSAME access mode allows
inserting multiple tasks that produce, each, a copy of the same
data. In the case where all these tasks are the same, i.e., use the
same function, same data and same arguments, we can actually speak of
\textit{task replication}. This however does not necessarily have
to be the case because in our approach nothing prevents these
tasks to use a different codelet, different data (other than the one
flagged with the \stfSAME access mode) or different
arguments. Obviously, in this case, it is the duty of the programmer
to ensure that these tasks produce the same data, or, at least,
copies that are equivalent for the purpose of the algorithm.

To
facilitate the usage of this feature, a wrapper function can be
implemented in the runtime system: %for some syntactic sugar:
this additional function, \stfinserts, takes a list of
replicating ranks \texttt{repl\_ranks} along with the usual arguments
(a codelet $T$, its own arguments, etc.). Note that
\stfinserts, with an ``s'', differs from
\stfinsert. This wrapper can be used to hide the usage of
the novel access mode: all \texttt{Write} accesses are appended with
\stfSAME and the task $T$ is submitted once for each rank in
\texttt{repl\_ranks} plus the owner if it was not included,
transparently for the user. Its use is exemplified in
Figure~\ref{alg:insert_tasks_sugar} for a piece of data $A$. It is
important that the task executed by the owner of the original data is
inserted last because each rank in \texttt{repl\_ranks} should receive
the initial, unmodified value of $A$. Consequently the owner of $A$ should
schedule sending the unmodified data before scheduling its own modification.
Likewise the owner rank should insert all
the tasks to ensure that every rank in \texttt{repl\_ranks} get the unmodified
value, but other ranks can prune the DAG.
% no more excuses, algorithm designers !!!
\begin{figure}[ht!]
	\centering
	\begin{subfigure}[t]{0.69\textwidth}
		\centering
		\begin{algorithmic}[1]
			\STATE \textcolor{myred}{\stfinserts}(\texttt{repl\_ranks},T,$A$:\stfRW)
		\end{algorithmic}
		\caption{A single replicated tasks insertion.}
	\end{subfigure}
	\begin{subfigure}[b]{0.69\textwidth}
		\centering
		\begin{algorithmic}[1]
			\STATE \texttt{repl\_ranks} $\gets$ unique(\{ \texttt{repl\_ranks}, $A$.owner \})
			\FOR{rank in \texttt{repl\_ranks}}
        \STATE \stfinsert(T, $A$:\stfRW \texttt{+} \textcolor{myred}{\stfSAME}, \texttt{rank:\stfONRANK})
			\ENDFOR
		\end{algorithmic}
		\caption{A \texttt{for}-loop to insert replicated tasks.}
	\end{subfigure}
	\caption{\stfinserts simplifies the use of the \stfSAME access mode. Both the
  top and the bottom part of the figure produce the same DAG.}
	\label{alg:insert_tasks_sugar}
\end{figure}

%\doneab{The paragraph below is very convoluted. I suggest:
%
%  I would put this paragraph before introducing the
%  \stfinserts wrapper because this makes sense only in the
%  case where we want to replicate tasks, not only data output.
%}
%
%The \stfSAME access mode's initial goal is to let the programmer
%momentarily relax the sequential consistency when modifying a single piece of
%data. This access mode naturally leads to the replication of tasks: by
%submitting the same codelet with the same arguments across multiple ranks, all
%these ranks obtain the modified value in their respective local memories. It is
%however not required that the codelet and arguments are identical. Such
%safeguards are not implemented nor required to effectively replicate data. This
%however puts the burden of correcting the DAG on the user rather than the
%runtime that could detect this usage.
%Because of the semantics of this feature, it is
%possible to schedule different tasks on different ranks with each task modifying
%the piece of data differently: to the runtime system, each value the replicated data
%is taking is considered identical. %thus avoiding data transfers.





%This feature
%arises because no specific constraints are imposed on the tasks that carry the
%replication -- thus the term ``task replication'' does not exactly fit what can
%be designed with this extension.
% Because of the pitfalls regarding correctness
% such usage of the access mode should be executed carefully as a runtime could
% detect distributed memory inconsistencies but mechanisms to do so remain to be
% specified and implemented. %Algorithms that would benefit from this behavior have not been explored.

%Without constraints,
%a data can be modified in multiple memories through any function taking any
%arguments
%Figure~\ref{alg:different_same} shows how the access mode
%can be used to modify a piece of data $A$ across different ranks while inserting
%different tasks for each rank. This feature could be leveraged in stochastic
%algorithms to select a different starting seed across different ranks.

%\begin{figure}[h]
%	\centering
%			\stfinsert(work,$A$:\texttt{RW+Same},args:\texttt{values[rank]})
%		}
%	\end{algorithmic}
%	\caption[Replicating tasks is not necessarily duplicating tasks.]
%		{Replicating tasks is not necessarily duplicating tasks.
%		By using \stfSAME precisely, it is possible to
%		submit tasks with different arguments (each rank uses a
%		different element in array \texttt{values} as arguments to
%		the work task).}
%	\label{alg:different_same}
%\end{figure}

With the proposed additions to the programming model, the DAG
presented in Figure~\ref{fig:dag.repl} can be expressed in an STF code
displayed in Figure~\ref{alg:third_pattern_expr}. This algorithm shows how
two very similar function calls in the STF programming model generate very
different behaviors: while \stfinsert and \stfinserts
have very similar arguments they lead to extremely dissimilar tradeoffs between
computation and communication workloads. Given a completely submitted DAG the
tradeoff of replicating tasks on several ranks may be evaluated by a
runtime system; this evaluation could lead to an automatic data write
replication. We have not evaluated the (engineering) cost of setting this detection mechanism up.
\begin{ab}
  les deux dernieres phrases ci-dessus je les mettrais plutot a la fin
  de l'article si on parle de future work
\end{ab}

\begin{figure}[h]
	\centering
	\begin{algorithmic}[1]
		\FOR{it=$\dots$}
			\STATE \textcolor{myblu}{\stfinsert(update,$A$:\stfRW)}
			\textbf{or} \\\textcolor{myred}{\stfinserts(\{0,1\},update,$A$:\stfRW)}
			\FOR{\texttt{rank} in \{0,1\}}
				\STATE \stfinsert(compute,$A$:\stfR,\texttt{rank}:\stfONRANK)
			\ENDFOR
		\ENDFOR
	\end{algorithmic}
	\caption[Figure~\ref{fig:dag.repl} submission algorithm.]
		{Either the blue or the red statement can be called. They
		 result in different DAGs. The blue one corresponds to the top
		 part of Figure~\ref{fig:dag.repl} whereas the red one
		 corresponds to the bottom part of the figure that leverages the
		 proposed extensions of the STF model.}
	\label{alg:third_pattern_expr}
\end{figure}

\subsubsection{Transferring from alternative ranks}

One straightforward advantage of using the \stfSAME access mode
on a data $D$ is that any subsequent local task needing $D$ will
actually use the redundantly computed local copy rather than fetching
$D$ from its owner. However, in the case where a task needing $D$ is
executed on a rank which does not possess a local copy, any of the
existing copies of $D$ can be transferred to that rank prior to the
execution of the task; a choice has to be made. A conservative policy
is to source $D$ from its owner. Although this approach is simple and
very robust, it might not be the most efficient. First it makes the
redundant computation only useful in a limited number of
cases where replicated data is only used locally. Second it may result in a loss of efficiency due to contention
issues on the owner rank which is involved in numerous
communications.
%As an example, consider the factorization algorithms
%detailed in Section~\ref{sec:back.repl.direct}. Here all the
%\texttt{trsm} tasks at a given iteration of the algorithm are spread
%over the existing layers of the 3D ranks grid; each of these tasks
%will fetch a copy of the diagonal block from a rank lying on the same
%layer.
To address this situation, we developed the following method,
which makes it possible to declare that a rank
\texttt{rcv\_rk} must retrieve a data \texttt{handle} from a designated rank
\texttt{new\_src} in subsequent tasks, rather than from its owner:

% \doneab{Satisfying=plaisant, satisfactory=satisfaisant. Check for
%   other occurrences}

% When exchanging data, a simple yet satisfactory policy is to schedule data
% movement with its owner. If a rank executes a task modifying a data, it will
% fetch the input value from the owner unless this data is already present in its
% local memory. When multiple copies of a data exist across the distributed
% memory, a choice can be made when fetching the data: the owner is not
% necessarily the best rank to make the request to. Indeed, the owner may be busy
% with other communication requests and contention may arise if data it owns is
% highly requested.

% In algorithms detailed in Section~\ref{sec:back.repl.direct}, communications of
% matrices' blocks need to be sourced from a different rank than the owner rank of
% said block. The following interface makes it possible to declare that a rank
% \texttt{rcv\_rk} retrieve a data \texttt{handle} from a specific rank
% \texttt{new\_src} in subsequent tasks.
\begin{itemize}
	\item \texttt{set\_alternative\_source(handle, rcv\_rk, new\_src)}
\end{itemize}
The default behavior of the runtime to fetch data from the owner rank is superseded:
when \texttt{new\_src} schedules data transfers for \texttt{handle} it is the
defined alternative rank that is used. Because the source rank is set in-between
task submission it is possible to benefit from other features already proposed
by a runtime system such as dynamic multicast communications~\cite{d.j.s.t:20}.

The \texttt{set\_alternative\_source} function may be called outside the
replication mechanism. In such a case no valid copy of the data described by
\texttt{handle} exists in \texttt{new\_src}: a preliminary transfer has to be
executed with the owner.
When the alternative source \texttt{new\_src} has been set, the cache mechanism
can be updated to account for the valid copy it possesses.
When replicating computation through \stfSAME, such a cache
entry is already set in the required state. Because
\texttt{set\_alternative\_source} mostly
consists in manipulating the records of the distributed-memory cache
it has no practical overhead when used conjointly with \stfSAME.


%This section first presents a STF interface for the allreduce reduction pattern
%in Section~\ref{sec:allredux}. Section~\ref{sec:scal_chol} then focuses on how to use
%this type of pattern combined with the replicating mechanism developed in
%Section~\ref{sec:repl} to propose STF expressions of scalable Cholesky
%decomposition algorithms.
%
%\subsection{Task-based allreduce STF DAG}
%\label{sec:allredux}

% \subsection{Allreduce}
% \label{sec:repl.allredux}
% 
% The approach we propose to implement the allreduce collective
% operation is based on an extension of the reduce operation presented
% by \citeauthor{a.b.g.h.j:23}~\cite{a.b.g.h.j:23}. Let us assume that $N$ ranks
% have, each, submitted a task updating some data $D$ which is passed
% with the \stfRKREDUX access mode. As explained by \citeauthor{a.b.g.h.j:23},
% the submission of tasks that
% operate the reduction can either be triggered implicitly, by
% submitting another task that requires $D$, or explicitly by calling a
% \texttt{redux\_submit} function. This is illustrated in
% Figure~\ref{fig:allreduce}~(\textit{top}). Equivalently, we can
% define an \texttt{allredux\_submit} method that, instead, inserts all
% the necessary tasks to operate an allreduce operation, in such a way
% that all participating ranks finally possess a copy of the assembled
% result.
% 
% \begin{figure}
%    \centering
%    %\incudegraphics[width=0.8\textwidth]{figures/allreduce.png}
%    \begin{subfigure}{0.68\columnwidth}
%        \centering
%        \begin{algorithmic}[H]
%        \STATE set\_redux(handle,redux,init)\;
%        \FOR{rank in contributing ranks}
%        \STATE insert\_task(\texttt{contrib},\\handle:\stfRKREDUX)\;
%        \ENDFOR
%        \STATE redux\_submit(handle)\;
%        \end{algorithmic}
%    \end{subfigure}
%    \begin{subfigure}{0.30\columnwidth}
%      \centering
%      \begin{tikzpicture}[scale=0.8]
% 
%        \pgfmathsetmacro{\own}{0}
%        \pgfmathsetmacro{\P}{3}
% 	     \pgfmathsetmacro{\r}{0.6}
%        \pgfmathsetmacro{\sz}{10pt}
%        \foreach \p in {0,...,\P}{
%          \ifthenelse{\p=\own}{
%            \node[very thick,fill=black,minimum size=5pt,draw,circle,inner sep=0pt] (i\p) at (\p*\r,0) {};
%          }{
% 		 \node[very thick,dashed,myred,fill=black!30,minimum size=\sz,draw,circle,inner sep=0pt] (i\p) at (\p*\r,0) {i};
%          }
%          \node[very thick,fill=mygre!30,minimum size=\sz,draw,circle,inner sep=0pt] (c\p) at (\p*\r,-1) {c};
% 
%          \pgfmathsetmacro{\pown}{int(Mod(\p,2))}
%          \pgfmathsetmacro{\Mown}{int(Mod(\own,2))}
%          \pgfmathsetmacro{\g}{int(\p/2)}
%          \ifthenelse{\pown=\Mown}{
%          	\node[very thick,dashed,myred,fill=myorg!30,minimum size=\sz,draw,circle,inner sep=0pt] (r1\g) at (\p*\r,-2) {r};
%          }{}
%          \pgfmathsetmacro{\g}{int(\p/1)}
%          \ifthenelse{\p=\own}{
%          	\node[very thick,dashed,myred,fill=myorg!30,minimum size=\sz,draw,circle,inner sep=0pt] (r2\g) at (\p*\r,-3) {r};
%          }{}
%        }
%        \foreach \p in {0,...,\P}{
%          \path[draw,thick,-latex] (i\p) -- (c\p);
%          \pgfmathsetmacro{\g}{int(\p/2)}
%          \path[draw,thick,-latex] (c\p) -- (r1\g);
%        }
%        \path[draw,thick,-latex] (r10) -- (r2\own);
%        \path[draw,thick,-latex] (r11) -- (r2\own);
% 
%      \end{tikzpicture}
%    \end{subfigure}
%    \begin{center}
%       \rule{2cm}{0.4pt}
%    \end{center}
%    \vspace{5pt}
%    \begin{subfigure}{0.68\columnwidth}
%        \centering
%        \begin{algorithmic}[H]
%        \STATE set\_redux(handle,redux,init)\;
%        \FOR{rank in contributing ranks}
%        \STATE insert\_task(\texttt{contrib},\\handle:\stfRKREDUX)\;
%        \ENDFOR
%        \STATE allredux\_submit(handle)\;
%        \end{algorithmic}
%    \end{subfigure}
%    \begin{subfigure}{0.30\columnwidth}
%      \centering
%      \begin{tikzpicture}[scale=0.8]
% 
%        \pgfmathsetmacro{\own}{0}
%        \pgfmathsetmacro{\P}{3}
%        \pgfmathsetmacro{\sz}{10pt}
% 	     \pgfmathsetmacro{\r}{0.6}
%        \foreach \p in {0,...,\P}{
%          \ifthenelse{\p=\own}{
%            \node[very thick,fill=black,minimum size=5pt,draw,circle,inner sep=0pt] (i\p) at (\p*\r,0) {};
%          }{
%            \node[very thick,dashed,myred,fill=black!30,minimum size=\sz,draw,circle,inner sep=0pt] (i\p) at (\p*\r,0) {i};
%          }
%          \node[very thick,fill=mygre!30,minimum size=\sz,draw,circle,inner sep=0pt] (c\p) at (\p*\r,-1) {c};
% 
%          \node[very thick,dashed,myred,fill=myorg!30,minimum size=\sz,draw,circle,inner sep=0pt] (r1\p) at (\p*\r,-2) {r};
%          \node[very thick,dashed,myred,fill=myorg!30,minimum size=\sz,draw,circle,inner sep=0pt] (r2\p) at (\p*\r,-3) {r};
%        }
%        \foreach \p in {0,...,\P}{
%          \path[draw,thick,-latex] (i\p) -- (c\p);
%          \pgfmathsetmacro{\g}{int(\p/2)}
%          \path[draw,thick,-latex] (c\p) -- (r1\p);
%          \path[draw,thick,-latex] (r1\p) -- (r2\p);
%        }
%        \foreach \p in {0,2}{
%          \pgfmathsetmacro{\pp}{int(\p+1)}
%          \path[draw,thick,-latex] (c\p) -- (r1\pp);
%          \path[draw,thick,-latex] (c\pp) -- (r1\p);
%        }
%        \foreach \p in {0,1}{
%          \pgfmathsetmacro{\pp}{int(\p+2)}
%          \path[draw,thick,-latex] (r1\p) -- (r2\pp);
%          \path[draw,thick,-latex] (r1\pp) -- (r2\p);
%        }
% 
%      \end{tikzpicture}
%    \end{subfigure}
%    \caption[STF reduce and allreduce operations]
% 	{The reduce or the allreduce operation can be submitted by the runtime
% system when the user provides a reduction codelet (orange tasks) and an
% initilization codelet (grey tasks). The submission can be triggered by the user once all the
% contributions (green tasks) have been submitted.}
%    \label{fig:allreduce}
% \end{figure}
% 
% A wide range of algorithms have been explored in the
% literature to address allreduce communication
% patterns~\cite{c.h.p.g:07,p.a.b.f.g.d:07}: exploring the variety of
% patterns that can be implemented is not the topic of this work.  These
% algorithms can be tailored to specific message sizes, network topology
% and number of contributing ranks. A naive yet reasonable approach is
% to implement a recursive doubling algorithm~\cite{k.s:73}.
% %; without
% %loss of generality, we focus on this approach and we reserve the
% %analysis of other patterns for future work.
% At the $k^{th}$ step of
% the recursive doubling, there exists $\mathcal{O}(\frac{N}{2^k})$
% different partial contributions, each of them held by
% $\mathcal{O}(2^k)$ reducing ranks over a total of $N$ reducing
% ranks. After $\mathcal{O}(\text{log}(N))$ steps all involved ranks
% hold the same result. Therefore, the \texttt{allredux\_submit} method,
% basically amounts to the pseudocode in Figure~\ref{alg:allredux}
% which presents a simplified version
% of the implemented algorithm where preliminary and postliminary steps
% required to handle the case where $N$ is not a power of two are
% discarded. This algorithm has to update the cache registry associated
% with $D$: after the DAG is submitted, the runtime should consider that
% all $N$ contributing ranks hold a coherent value of
% $D$. Figure~\ref{fig:allreduce}~(\textit{bottom}) shows how the
% \texttt{allredux\_submit} can be used in place of the
% \texttt{redux\_submit} to achieve an allreduce operation.
% 
% 
% % The runtime
% % should expose this implementation inside a function
% % \texttt{allredux\_submit}.  Now, the user can benefit from both the
% % reduction through \texttt{redux\_submit} and from the allreduce
% % operation.
% 
% \begin{figure}
% \begin{algorithmic}
% 	\STATE contributors $\gets$ $N$ contributing ranks\;
% 	\STATE my\_id $\gets$ index of \texttt{me} in contributors\;
% 	\STATE arity $\gets$ 1\;
% 	\WHILE{arity $< 2^{\text{log}_2(N)}$}
% 		\IF{$\frac{my\_id}{arity}\%2 == 0$}
% 			\STATE partner $\gets$ contributors[my\_id-arity];
% 		\ELSE
% 			\STATE partner $\gets$ contributors[my\_id+arity];
% 		\ENDIF
% 		\STATE \textcolor{myred}{\stfinsert}(isend, D:\textcolor{myred}{\stfR}, partner)\;
% 		\STATE T $\gets$ duplicate of handle describing D\;
% 		\STATE \textcolor{myred}{\stfinsert}(irecv, T:\textcolor{myred}{\stfR}, partner)\;
% 		\STATE \textcolor{myred}{\stfinsert}(redux, D:\textcolor{myred}{\stfRW}, T:\textcolor{myred}{\stfR})\;
% 		\STATE \textcolor{myred}{\stfinsert}(invalidate, T:\textcolor{myred}{\stfW})\;
% 		\STATE arity $\gets$ arity * 2\;
% 	\ENDWHILE
% 	\STATE update\_cache()\;
% \end{algorithmic}
% \caption[STF allreduce subgraph submission.]
% {Program to submit the sub-graph describing allreduce operation
% over a piece of data $D$ using $N$ contributing ranks. This sub-graph is
% submitted by rank \texttt{me}.}
% \label{alg:allredux}
% \end{figure}
% 
% The question arises of whether it is possible to implicitly trigger
% the insertion of the allreduce tasks as it is the case for the reduce
% operation. Obviously, if both operations rely on the same
% \stfRKREDUX access mode, this is not possible because the
% runtime has no way of deciding whether to insert tasks to achieve a
% reduce or an allreduce. This problem can be overcome by introducing a
% new access mode, say, \texttt{RANK\_ALLREDUX}; then, as soon as
% another task which uses the data in \stfR or \stfW mode is
% inserted, the runtime can automatically insert tasks to operate an
% allreduce among all the ranks that have previously submitted a task with
% this access mode. This clearly requires much more intrusive
% modifications of the runtime and we reserve it for future work. It
% must also be noted that the use of the \texttt{allredux\_submit} makes
% it possible to implement the allreduce operation as an all-to-many
% collective communication. In this case the set of ranks owning a copy
% of the final assembled result can be different (a subset or a
% completely different set) than the set owning the data to be reduced;
% this can be achieved by passing a list of destination ranks to the
% \texttt{allredux\_submit} method. This feature has been also considered for
% future work as a more appropriate algorithm than recursive doubling is required.
% 
% %\subsection{Automatic detection}
% % In Figure~\ref{alg:redux-example}, the following DAG is submitted: contributions are
% % computed over several ranks through \texttt{contrib} tasks then a reduction
% % operation is submitted and the result of the reduction is used by another set of
% % ranks through \texttt{use} tasks. Section~\ref{sec:stf-x-features} briefly outlines
% % the behavior of the runtime for reduce. Indeed, the user does not need to call
% % \texttt{redux\_submit} themself: the runtime is perfectly capable of triggering
% % such a function call. In the presented algorithm, this trigger is set upon
% % submitting the \texttt{use} tasks. An automatic detection mechanism can be
% % plugged in the runtime so that it triggers when the access mode over the reduced
% % data switches from \stfRKREDUX to \texttt{R} and/or \texttt{W}. The
% % allreduce operation could benefit from such an automatic detection mechanism
% % with a similar ease however it is clear that the proposed semantics do not allow
% % to distinguish between the two operations simply. Several ways could be proposed
% % to make the distinction possible. Runtime developpers have to choose which one
% % seem more favorable to add in their existing implementation.
% % \begin{itemize}
% % \item %
% % The reduce operation leverages the \stfRKREDUX access mode. To make a
% % distinction with the allreduce operation, a \texttt{RANK\_ALLREDUX} access mode
% % could be added to the interface of the programming model. Then the runtime only
% % has to register which mode was used to trigger either of the two functions.
% % While
% % quite concise and easy to implement, this approach could be confusing to a
% % user. Indeed, the \stfRKREDUX and \texttt{RANK\_ALLREDUX} access modes
% % essentially behave the same before contributions are assembled. It is not
% % obvious that this implementation would be clear to grasp for users.
% % \item %
% % Reduction patterns are not only described when submitting the DAG. They are also
% % described preliminarily as initilization and reduction codelets have to be
% % provided to instantiate tasks. When this description is given, the user could
% % state whether they would unroll a reduce or an allreduce. Then the runtime can
% % follow the user's guideline when the DAG of the reduction has to be submitted.
% % This approach is static and may not be the most favorable if the runtime can
% % be extended to choose between either reductions.
% % \item %
% % Because of their similarity the decision to schedule either of the operations has to be
% % compared. Scheduling such a decision is out of the scope of this work: while it may
% % be beneficial to leverage an allreduce instead of a reduce followed by a
% % broadcast the effective benefit is largely application- and platform-dependent.
% % As a result, a reasonable choice is to not modify the runtime further. Reduce can
% % remain  automatically detected and allreduce will be invoked explicitly by
% % users when they see fit.
% % \end{itemize}
% 
% % \begin{algorithm}[h]
% % set\_reduction\_methods(handle,redux,init)\;
% % \For{rank in contributing ranks}{
% % insert\_task(\texttt{contrib},handle:\stfRKREDUX)\;
% % }
% % allredux\_submit(handle)\texttt{+}redux\_submit(handle)\;
% % \For{rank in using ranks}{
% % insert\_task(\texttt{use},handle:\texttt{R})\;
% % }
% % \caption[Users can either use reduce or allreduce explicitly.]
% % {Users can either use reduce or allreduce explicitly.}
% % \label{alg:redux-example}
% % \end{algorithm}
% 
% %In Section~\ref{sec:stf-matrix-multiply}, the reduction operation is triggered
% %as soon as a subsequent task with \texttt{Write} or \texttt{Read} access on the
% %data is inserted. This automatic detection is simple to implement as it amounts
% %to the evaluation of key statements when processing a task before scheduling it. For
% %reduction patterns, the statements to check are whether a
% %reduction is ongoing based on previous access modes and whether the current
% %access mode is not part of a reduction. It could be possible to choose specific
% %access modes to target either one of the two reduction patterns but this
% %proposition seems inadequate when our goal is to target readability: having the
% %runtime handle \texttt{Rank\_REDUX} and \texttt{Rank\_ALLREDUX} modes on top of
% %the usual access modes force the runtime to take care of many cases --
% %including the ones that should throw an error because the user is submitting
% %tasks in a way that the runtime does not know how to handle. For instance,
% %the runtime should have to decide what reduction operation to execute if a piece
% %of data is first accessed with \texttt{Rank\_Redux} then with
% %\texttt{Rank\_ALLREDUX}. Because of this complexity, we discard this solution.
% 
% % In this work, we favored the simpler third option. The factorization algorithms
% % presented in this work explicitly use the \texttt{allredux\_submit} function to
% % obtain the designed behaviors. While this solution hinders expressivity, it is a
% % temporary inconvenience that can be resolved in future work.
% % Note however that our addition of
% % \texttt{allredux\_submit} inside StarPU makes it now possible to consider
% % consolidating distributed memory scheduling policies to favor reduce over
% % allreduce. \texttt{allredux\_submit} only requires the \texttt{handle} of the
% % allreduced data to execute.
% %Because of this difficulty, the reduce operation remains automatically
% %detected but we consider that triggering the allreduce pattern has to be
% %explicitly submitted by the user. The function \texttt{allredux\_submit}
% %submits an allreduce operation for the data described by handle \texttt{handle}.
% 
% % \begin{itemize}
% 	% \item \texttt{allredux\_submit(handle)}
% % \end{itemize}
% 
% % Upon calling \texttt{allredux\_submit}, the data described by \texttt{handle} is
% % considered valid across the contributing ranks. These ranks can then be used as
% % alternative sources through the \texttt{set\_alternative\_source}.
% 
% %\todoaj{Je peux au moins ajouter la possibilité de flag quand on appelle
% %\_add\_reduction\_methods ; ça me prendra pas + d'1h IMO ; en revanche la
% %détection automatique c'est beaucoup trop compliqué}
% 
% 
% %The three proposed additions to the runtime system~-- the \stfSAME
% %access mode, the \texttt{set\_alternative\_source} function and the
% %\texttt{allredux\_submit} wrapper~-- are better used
% %simultaneously. If a piece of data $D$ is replicated by $R$ ranks among $P$, it
% %can be beneficial to start collective operations involving $D$ by relying on the $R$
% %sources. This gain is made clearer when taking into account the topology of the
% %network: assume $8$ ranks distributed across $2$ large computing nodes of $4$
% %NUMA domains each. In this case, it is very clear that ranks on the same computing
% %node can exchange data faster than with the other computing node that exists
% %across the network. Figure~\ref{fig:repl.exmpl} showcases the situation as well
% %as an example of an algorithm that can be executed. Improvements allowed by
% %our extensions are highlighted but they are not necessary to obtain a correct
% %result.
% %
% %\begin{figure}[ht!]
% %	\centering
% %	\begin{subfigure}{0.69\textwidth}
% %		\centering
% %		register D on 0
% %		insert\_task(\texttt{partial\_work}, D:\textcolor{myred}{RANK\_REDUX}, ON:0)
% %		insert\_task(\texttt{partial\_work}, D:\textcolor{myred}{RANK\_REDUX}, ON:4)
% %		\textcolor{myblu}{all\_redux\_submit} D
% %		\textcolor{myblu}{insert\_tasks}(\{0,4\},\texttt{update},D:\textcolor{myred}{RW})
% %			\textcolor{myblu}{set\_alternative\_source}(D, n, 4)
% %		}
% %			insert\_task(\texttt{work}, D:\textcolor{myred}{R}, ON:n)
% %		}
% %		\end{algorithmic}
% %		\caption{An algorithm that first reduces a data $D$ across
% %computing nodes then sends it to all the ranks after ranks contributing to the
% %reduction have updated it.}
% %		\label{fig:repl.exmpl.code}
% %	\end{subfigure}
% %	\begin{subfigure}{0.29\textwidth}
% %		\centering
% %		\begin{tikzpicture}[rotate=90]
% %			\foreach \N in {0,1} {
% %				\foreach \p in {0,1,2,3} {
% %		% consider doing something to get 0 close to 4
% %		\ifthenelse{\N=1}{
% %			\pgfmathsetmacro{\rk}{int(\N*4+\p)}
% %			\pgfmathsetmacro{\x}{int(\N*4 + Mod(\p,2))}
% %			\pgfmathsetmacro{\y}{int(\p/2)}
% %		}{
% %			\pgfmathsetmacro{\rk}{int(Mod(\N*4+\p,4))}
% %			\pgfmathsetmacro{\x}{int(\N*4 + Mod(\p,2))}
% %			\pgfmathsetmacro{\y}{int(\p/2)}
% %		}
% %		\node[draw,rectangle] (r\rk) at (\x,\y) {\rk};
% %				}
% %				\pgfmathsetmacro{\rka}{int(\N*4+0)}
% %				\pgfmathsetmacro{\rkb}{int(\N*4+1)}
% %				\pgfmathsetmacro{\rkc}{int(\N*4+2)}
% %				\pgfmathsetmacro{\rkd}{int(\N*4+3)}
% %				\path[draw, line width=10pt, mygre] (r\rka) -- (r\rkb);
% %				\path[draw, line width=10pt, mygre] (r\rka) -- (r\rkc);
% %				\path[draw, line width=10pt, mygre] (r\rkd) -- (r\rkb);
% %				\path[draw, line width=10pt, mygre] (r\rkd) -- (r\rkc);
% %			}
% %			\path[draw, line width=4pt, myorg] (r0) ..
% %				controls ($(r0)!0.1!(r4) + (0,-0.5)$) and ($(r0)!0.9!(r4) + (0,-0.5)$)
% %					.. (r4);
% %		\end{tikzpicture}
% %		\caption{Replicating work using 2 computing nodes of 4 numa
% %nodes each.}
% %		\label{fig:repl.exmpl.topo}
% %	\end{subfigure}
% %	\caption{Some situation.}
% %	\label{fig:repl.exmpl}
% %\end{figure}
% %
% %The cost $W$ of communicating over the network is considered greater than the
% %cost $w$ of communicating over NUMA domains. It should be noted that contention
% %over the network may serialize communications if several transfers are scheduled
% %over the same link between two NUMA domains in the same direction.
% %
% %When collective operations patterns can be inferred, as is the case for the
% %\texttt{work} task independently executed by every ranks that use $D$, a
% %binomial broadcast tree -- or any other tree if the user so desires -- can be
% %detected and unrolled by the communications library. The order of submission
% %guides the order of the ranks in the binomial tree. In this situation, without
% %the extensions highlighted in blue, the sequences of transfers is as follows.
% %The type of link used is indicated on top of the arrow linking the source and
% %the destination of a transfer of $D$.
% %
% %\begin{center}
% %\begin{enumerate}
% %	\item $4 \xrightarrow{W} 0$: 4 sends its partial contribution to 0.
% %	\item $0 \xrightarrow{w} 1$: 0 starts the binomial tree broadcast after
% %		updating $D$.
% %	\item $0 \xrightarrow{w} 2$; $1 \xrightarrow{w} 3$
% %	\item $0 \xrightarrow{W} 4$; $1 \xrightarrow{W} 5$; $2 \xrightarrow{W} 6$; $3 \xrightarrow{W} 7$
% %\end{enumerate}
% %\end{center}
% %
% %With our proposed extensions, one step less is required -- assuming each link
% %between ranks is bidirectional. Moreover it can be noted that transfers
% %across the network are performed only when transferring the results of the
% %\texttt{partial\_work} tasks. All other transfers are scheduled between NUMA
% %domains on the same computing node which should make them more efficient.
% %
% %\begin{center}
% %\begin{enumerate}
% %	\item $0 \xleftrightarrow{W} 4$: 0 and 4 exchange their partial
% %		contributions.
% %	\item $0 \xrightarrow{w} 1$; $4 \xrightarrow{w} 5$: 0 and 4 proceeds
% %		with independant broadcast using a binomial tree after
% %		replicating the update on $D$.
% %	\item $0 \xrightarrow{w} 2$; $1 \xrightarrow{w} 3$; $4 \xrightarrow{w} 6$; $5 \xrightarrow{w} 7$
% %\end{enumerate}
% %\end{center}
% %
% %Note that it is possible to reorder the collective binomial tree to ensure that
% %the cost of communications matches with the one achieved through the extended
% %programming model. Such a reordering can be hinted at through the priorities
% %provided for each \texttt{work} task. While the same benefit is obtained --
% %communications are alloted across computing nodes separately -- it requires the
% %user to know the exact topology of the network they use. Such an information, as
% %well as the linear map between the most prioritized tasks and their position in
% %the binomial tree, may be hard to simply adapt inside the code. The proposed approach,
% %setting alternative sources, fully leverages the transparency of the dynamic
% %broadcast detection while hinting at the topology and not fully disclosing it to
% %the runtime. Indeed, the important information the runtime is given is the
% %difference between links \emph{e.g.} ranks 5,6 and 7 are closer to 4 than they
% %are to rank 0 (see Figure~\ref{fig:repl.exmpl}).
% 
% % \section{Solving systems by replicating computation in the STF programming model}
% 
% %Sections~\ref{sec:repl.runtime} and \ref{sec:repl.allredux} details key features
% %required to express the algorithms presented in
% %Section~\ref{sec:back.repl.direct} and Section~\ref{sec:back.repl.iterative}. In
% %this section, we provide a task-based expression of these algorithms. We assess
% %the scalability of the different algorithmic variants now offered by the STF
% %programming model and discuss limitations of our approach.
% 
% 
%%% Local Variables:
%%% mode: latex
%%% TeX-master: "submission"
%%% TeX-command-extra-options: "-shell-escape --enable-write18 --synctex=1"
%%% jinx-languages: "en"
%%% End:
